%% Initiate our clean workspace and apply basic PTB default settings
sca;
close all;
clearvars;

Screen('Preference', 'SkipSyncTests', 0)
PsychDefaultSetup(2);

%% Insert DATAPixx code to open a USB connection and to initialize the controller
Datapixx('Open');
Datapixx('StopAllSchedules');
Datapixx('RegWrRd');

%% todo DATAPixx code to initialize the Din log
%
%
%
%



%% % Use PTB to open up a testing window and setup the stimulus presentation code.
screenNumber = max(Screen('Screens')) % Open a widow on the display with the largest identification number.
[window, windowRect] = PsychImaging('OpenWindow', screenNumber, BlackIndex(screenNumber));
[xCenter, yCenter] = RectCenter(windowRect);
baseRect = [0 0 200 200];
centeredRect = CenterRectOnPointd(baseRect, xCenter, yCenter);

HideCursor(screenNumber);


%% Main stimulus loop
nRep = 5;
%
%
%

for i = 1:nRep
    % todo Wait until all buttons are up. Use the rapid and efficient bitand
    % function to verify if all of the relevant digital input values are in
    % the correct position (1). We will see how to edit the 'up' buttons
    % later.
    %
    %
    %
    
    % todo 'Flush' any past button presses by resseting the Din Logger.
    
    %
    %
    
    Screen('FillRect', window, [1 1 1], centeredRect);
    
    %% Insert a random delay with Datapixx('GetTime');
    delay(i) =0.5 + rand/2;% 0.5s to 1 second delay
    preTrialStartTime = Datapixx('GetTime');
    trialStartTime = preTrialStartTime+ delay(i);
    
    while (Datapixx('GetTime') < trialStartTime)
        Datapixx('RegWrRd');
    end
    
    %% Insert a marker on the next frame flip with Datapixx('SetMarker');
    Datapixx('SetMarker');
    Datapixx('RegWrVideoSync');
    
    %% Display the white square with PTB's Screen('Flip')
    Screen('Flip', window);
    
    %% Continue looping until any button has been pressed. Store the result
    % todo Dummy while loop. Will only exit once we detect a new logged frame and 'break' out of the loop
    %
    %
    %
    
    %%
    % todo If a status change is detected, read and store the value.
    %
    %
    %
    %
           %% Insert DATAPixx code that reads the time value of the marker associated with the frame flip.
            stimulusOnsetTime = Datapixx('GetMarker'); %
            % *i
            %
    %
    
    
    
    %% Display a black square to mask the stimulus before looping back.
    Screen('FillRect', window, [0 0 0], centeredRect);
    Screen('Flip', window);
end
%% Close our PTB stimulus window and terminate presentation
sca;
ShowCursor();

%% Calculate the reaction times and display the buttons that were pressed.
%
%
%
%
%
%
%

%% Insert DATAPixx code to close the USB connection to the data acquisition system
Datapixx('Close')

